////////////////////////////////////////////////////////////////////////////////
// CONFIDENTIAL and PROPRIETARY software of Magewell Electronics Co., Ltd.
// Copyright (c) 2011-2019 Magewell Electronics Co., Ltd. (Nanjing)
// All rights reserved.
// This copyright notice MUST be reproduced on all authorized copies.
////////////////////////////////////////////////////////////////////////////////

#import <Cocoa/Cocoa.h>
#import <AVFoundation/AVSampleBufferDisplayLayer.h>

#include "MWFOURCC.h"
#include "LibMWCapture/MWCapture.h"
#include "MWAudioRender.h"

@interface ViewController : NSViewController <NSWindowDelegate>

//video params
@property (nonatomic, assign) uint32_t width;
@property (nonatomic, assign) uint32_t height;
@property (nonatomic, assign) uint32_t frameDuration;
@property (nonatomic, assign) uint32_t fourcc;

//audio params
@property (nonatomic, assign) uint32_t samplerate;
@property (nonatomic, assign) uint32_t audioChannels;
@property (nonatomic, assign) uint32_t bitsPerSample;

//av capture
@property (nonatomic, assign) void  *audioRender;
@property (nonatomic, assign) HANDLE audioCapture;
@property (nonatomic, assign) HANDLE videoCapture;

- (void)onVideoCaptureFrame:(BYTE *)pBuffer bufferLen:(long)bufferLen stride:(long) stride;
- (void)onAudioCaptureFrame:(BYTE *)pbFrame cbFrame:(int)cbFrame u64TimeStamp:(uint64_t)u64TimeStamp;

//statistics
@property (atomic, assign) float captureFps;
@property (nonatomic, assign) uint64_t lastTimestamp;
@property (nonatomic, assign) uint32_t videoFrameCount;

//UI
@property (nonatomic, assign) int32_t viewEnable;
@property (nonatomic, retain) AVSampleBufferDisplayLayer *videoLayer;
@property (nonatomic, assign) OSType pixelFormat;
@property (nonatomic, retain) NSMenu *deviceMenu;
@property (nonatomic, retain) NSMenuItem *selectedDeviceItem;
@property (nonatomic, retain) NSMenu *audioMenu;
@property (nonatomic, retain) NSMenuItem *selectedAudioItem;
@property (weak) IBOutlet NSTextField *statusLabel;
@property (nonatomic, retain) NSTimer *statusTimer;

@end

